﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public astream As AsyncStreams
	Private socket As Socket
	Public connected As Boolean
	Private watchdog As Timer
	Private lastValueTime As Long
	Private ser As B4RSerializator
	
	public wifi As MLwifi
End Sub

Sub Service_Create
	watchdog.Initialize("watchdog", 10000)
	ser.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Connect(ip As String)
	Dim xflag, xOk As Boolean
	Dim xCnt As Int
	wifi.disconnectWifiAP
	Sleep ( 2000)
	wifi.connectWifiAP ("SOSApp")
	xflag = True
	xCnt = 0
	xOk = False
	Do While xflag
		Sleep ( 3000)
		If wifi.WifiSSID = "SOSApp" Then
			xflag = False			
			xOk = True
		End If
		xCnt = xCnt + 1
		If xCnt = 4 Then
			xflag = False
		End If
	Loop
	
	If xOk Then
		Log ( "Conctado SOSApp" )
		connected = True
		CallSub(Main, "StateChanged")
	Else
		connected = False
		Log ( "Não conectado: " & wifi.WifiSSID)
	End If
	
	
'	If astream.IsInitialized Then
'		astream.Close
'	End If
'	socket.Initialize("socket")
'	socket.Connect(ip, 51042, 30000)
End Sub

Private Sub Socket_Connected (Successful As Boolean)
	If Successful Then
		connected = True
'		astream.InitializePrefix(socket.InputStream, False, socket.OutputStream, "Astream")
		CallSub(Main, "StateChanged")
'		watchdog.Enabled = True
		lastValueTime = DateTime.Now
	End If
End Sub

Private Sub Astream_NewData (Buffer() As Byte)
Log ( "Envia")
'	CallSub2(Main, "NewValue", ser.ConvertBytesToArray(Buffer))
'	lastValueTime = DateTime.Now
'	astream.Write(ser.ConvertArrayToBytes(Array("Sent from B4A", DateTime.Time(DateTime.Now), True)))
End Sub

Private Sub Astream_Error
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
	watchdog.Enabled = False
End Sub

Private Sub Astream_Terminated
	Astream_Error
End Sub

Private Sub Watchdog_Tick
'	If DateTime.Now - lastValueTime > 10 * DateTime.TicksPerSecond Then
'		Log("Watchdog closing connection.")
'		If astream.IsInitialized Then astream.Close
'		Astream_Error
'	End If
End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
